<script>
	import {io} from 'socket.io-client'
	import {relURL} from './util/network'
	import store from './util/store'
	import Messages from './messages.svelte'
	import Inputs from './inputs.svelte'

	const socket = io(relURL('/'),{path: '/echo'})
	let messages = []
	let name = store('name', 'guest')
	let typers = new Map()
	export let status
	$: status = typers.size? [...typers.values()].join(', ') + ` ${typers.size===1? 'is': 'are'} typing...`: ''

	const doJoin = ({name})=>{
		messages.push({message: `${name} joined`})
		messages = messages
	}
	const doLeave = ({name})=>{
		messages.push({message: `${name} left`})
		messages = messages
	}
	const doRename = ({name, rename})=>{
		messages.push({message: `${name} renamed to ${rename}`})
		messages = messages
	}
	const doTyping = ({id, name})=>{
		typers.set(id, name)
		typers = typers
		console.log(`${name} is typing`)
	}
	const doStopTyping = ({id})=>{
		typers.delete(id)
		typers = typers
	}
	const doMessage = ({name, message})=>{
		messages.push({name, message})
		messages = messages
	}
	socket.on('connect', ()=>{
		console.log(`connected ${socket.id}`)
		socket.emit('join', $name)
	})
	socket.on('disconnect', reason=> console.log(`disconnected ${socket.id}: ${reason}`))
	socket.on('join', doJoin)
	socket.on('leave', doLeave)
	socket.on('rename', doRename)
	socket.on('message', doMessage)
	socket.on('typing', doTyping)
	socket.on('stop typing', doStopTyping)
</script>
<style>
	#container{
		flex: 1 1 auto;
		align-self: stretch;
		display: flex;
		flex-flow: column;
	}
</style>
<div id='container'>
	<Messages bind:messages/>
	<Inputs bind:name={$name}
		on:rename={({detail: rename})=>{
			doRename({name: $name, rename})
			socket.emit('rename', rename)
		}}
		on:typing={()=> socket.emit('typing')}
		on:stopTyping={()=> socket.emit('stop typing')}
		on:message={({detail: message})=>{
			socket.emit('message', message)
			doMessage({name: $name, message})
		}}
	/>
</div>
